#![no_std]
#![no_main]

#![feature(allocator_api)]
#![allow(dead_code)]
#![allow(unused_imports)]

use core::arch::asm;

use gila::boot::*;
use gila::process;
use gila::memory;
use gila::panic;
use gila::boot;
use gila::display::{self, TextWriter};

#[unsafe(no_mangle)]
unsafe extern "C" fn main() -> !{

    assert!(BASE_REVISION.is_supported());

    let _smp_response = SMP_REQUEST.get_response();

    loop {
        unsafe {
            #[cfg(target_arch = "x86_64")]
            asm!("hlt");
            #[cfg(any(target_arch = "aarch64", target_arch = "riscv64"))]
            asm!("wfi");
            #[cfg(target_arch = "loongarch64")]
            asm!("idle 0");
        }
    }

}
